<template>
  <div class="app-container">
    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="45%" v-dialogDrag append-to-body>
      <el-form ref="formRef" :model="formData" :rules="formRules" v-loading="formLoading" label-width="100px">
                    <el-form-item label="父分类" prop="parentId">
                      <TreeSelect
                        v-model="formData.parentId"
                        :options="materialCategoryTree"
                        :normalizer="normalizer"
                        placeholder="请选择父分类"
                      />
                    </el-form-item>
                    <el-form-item label="分类名称" prop="name">
                      <el-input v-model="formData.name" placeholder="请输入分类名称" />
                    </el-form-item>
                    <el-form-item label="分类层级" prop="level">
                      <el-input v-model="formData.level" placeholder="请输入分类层级" />
                    </el-form-item>
                    <el-form-item label="排序" prop="sort">
                      <el-input v-model="formData.sort" placeholder="请输入排序" />
                    </el-form-item>
<!--                    <el-form-item label="状态" prop="status">
                      <el-radio-group v-model="formData.status">
                            <el-radio v-for="dict in this.getDictDatas(DICT_TYPE.TRS_STATUS)"
                                      :key="dict.value" :label="dict.value">{{dict.label}}</el-radio>
                      </el-radio-group>
                    </el-form-item>-->
      </el-form>
              <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :disabled="formLoading">确 定</el-button>
        <el-button @click="dialogVisible = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import * as MaterialCategoryApi from '@/api/server/materialcategory';
    import TreeSelect from "@riophae/vue-treeselect";
  import "@riophae/vue-treeselect/dist/vue-treeselect.css";
    export default {
    name: "MaterialCategoryForm",
    components: {
                  TreeSelect,
            },
    data() {
      return {
        // 弹出层标题
        dialogTitle: "",
        // 是否显示弹出层
        dialogVisible: false,
        // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
        formLoading: false,
        // 表单参数
        formData: {
                            id: undefined,
                            parentId: undefined,
                            name: undefined,
                            level: undefined,
                            sort: undefined,
                            status: undefined,
        },
        // 表单校验
        formRules: {
                        parentId: [{ required: true, message: '父分类不能为空', trigger: 'blur' }],
                        name: [{ required: true, message: '分类名称不能为空', trigger: 'blur' }],
                        level: [{ required: true, message: '分类层级不能为空', trigger: 'blur' }],
        },
                       materialCategoryTree: [], // 树形结构
              };
    },
    methods: {
      /** 打开弹窗 */
     async open(id) {
        this.dialogVisible = true;
        this.reset();
        // 修改时，设置数据
        if (id) {
          this.formLoading = true;
          try {
            const res = await MaterialCategoryApi.getMaterialCategory(id);
            this.formData = res.data;
            this.title = "修改资料分类";
          } finally {
            this.formLoading = false;
          }
        }
        this.title = "新增资料分类";
                await this.getMaterialCategoryTree();
      },
      /** 提交按钮 */
      async submitForm() {
        // 校验主表
        await this.$refs["formRef"].validate();
                  this.formLoading = true;
        try {
          const data = this.formData;
                  // 修改的提交
          if (data.id) {
            await MaterialCategoryApi.updateMaterialCategory(data);
            this.$modal.msgSuccess("修改成功");
            this.dialogVisible = false;
            this.$emit('success');
            return;
          }
          // 添加的提交
          await MaterialCategoryApi.createMaterialCategory(data);
          this.$modal.msgSuccess("新增成功");
          this.dialogVisible = false;
          this.$emit('success');
        } finally {
          this.formLoading = false;
        }
      },
                  /** 获得资料分类树 */
         async getMaterialCategoryTree() {
            this.materialCategoryTree = [];
            const res = await MaterialCategoryApi.getMaterialCategoryList();
            const root = { id: 0, name: '顶级资料分类', children: [] };
            root.children = this.handleTree(res.data, 'id', 'parentId')
            this.materialCategoryTree.push(root)
          },
                  /** 转换资料分类数据结构 */
          normalizer(node) {
            if (node.children && !node.children.length) {
              delete node.children;
            }
                return {
                  id: node.id,
                  label: node.name,
                  children: node.children
                };
          },
      /** 表单重置 */
      reset() {
        this.formData = {
                            id: undefined,
                            parentId: undefined,
                            name: undefined,
                            level: undefined,
                            sort: undefined,
                            status: undefined,
        };
        this.resetForm("formRef");
      }
    }
  };
</script>
